//*****************************************************************************************************
//  1. t@C
//		MmeFile.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		MMEHwlϊNX̎
//----------------------------------------------------------------------------------------------------
//  3. l
//		
//----------------------------------------------------------------------------------------------------
//  4. 
//		2013.10.22 S.Aizawa VK쐬
//*****************************************************************************************************

#include "StdAfx.h"
#include "MmeFile.h"
#include "MMA_G.h"
#include "GlobalData.h"
#include "General.h"
#include "shlwapi.h"

// MMEinit@C
#define MME_INI_FILE "mme.ini"

// oCgf[^烏[hf[^֕ϊ
#define GETWORD(b1, b2) (((WORD)(b1) << 8) | (b2))
#define GETDWORD(b1, b2, b3, b4) (((((((DWORD)(b1) << 8) | (b2)) << 8) | (b3)) << 8) | (b4))

// pPbgf[^TCY
#define PACKET_TIME_SIZE	8
#define USER_HEADER_SIZE	16
#define ACC_DATA_SIZE		20

// őt@CTCY(1.2GB -> 5.0GB)
//#define MAX_DATA_SIZE	(ULONGLONG)(1.2 * 1024 * 1024 * 1024)
#define MAX_DATA_SIZE	(ULONGLONG)(5.0 * 1024 * 1024 * 1024)	// 2014/04/14 modified by y.GOTO

CMmeFile::CMmeFile(void)
{
	memset(m_nSamplingRate, 0, sizeof(m_nSamplingRate));
	m_bOverWrite = FALSE;
}

CMmeFile::~CMmeFile(void)
{
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::CheckDataFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		f[^tH_̒`FbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR		pDataFolder		[I] f[^tH_pX
//		CTime		&oStartTime		[O] vJn
//		CTime		&oEndTime		[O] vI
//		int			&nMeasTime		[O] vb
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE:@FALSE:G[
//*****************************************************************************************************
BOOL CMmeFile::CheckDataFile(LPCTSTR pDataFolder, CTime &oStartTime, CTime &oEndTime, int &nMeasTime)
{
	m_sDataFolder = pDataFolder;

	// f[^t@CpX擾
	CStringArray saDataFiles;
	GetDataFiles(saDataFiles);

	// .st@C݃`FbN
	if (saDataFiles.GetCount() == 0) {
		CGeneral::Alert("_ENt@C݂܂B");
		return FALSE;
	}

	// f[^TCY`FbN
	if (GetTotalFileSize(saDataFiles) > MAX_DATA_SIZE) {
		CGeneral::Alert("t@CTCY𒴂Ă܂B");
		return FALSE;
	}

	// ^CX^vǂݍ
	TimestampArray oTimestampArray;
	DataBlock oDataBlock;
	{
		CWaitCursor cursor;

		// ^CX^v擾
		m_nPacketCount = 0;
		GetTimestamp(saDataFiles, oTimestampArray, NULL);

		// f[^ubN擾
		GetDataBlock(oTimestampArray, oDataBlock);
	}

	// ϊς݃t@C݃`FbN
	m_bOverWrite = CheckExistFile(oDataBlock);

	// JnAI擾
	UINT nStartTime = UINT_MAX;
	UINT nEndTime = 0;
	for (int nRange = 0; nRange < N_RANGE; nRange++) {
		if (oTimestampArray[0][nRange].GetCount() != 0) {
			nStartTime = min(nStartTime, oTimestampArray[0][nRange][0]);
			nEndTime = max(nEndTime, oTimestampArray[0][nRange][oTimestampArray[0][nRange].GetCount() - 1]);
		}
	}
	if (nStartTime == UINT_MAX || nEndTime == 0) {
		CGeneral::Alert("t@C̒ɗLȃf[^݂ȂA܂̓f[^słB");
		return FALSE;

	}
	oStartTime = GetTime(nStartTime);
	oEndTime = GetTime(nEndTime);

	// vԎ擾
	nMeasTime = 0;
	for (int nRange = 0; nRange < N_RANGE; nRange++) {
		nMeasTime += (UINT)oTimestampArray[0][nRange].GetCount();
	}

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::GetDataFiles
//----------------------------------------------------------------------------------------------------
//  2. @\
//		gq.s̃t@C擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CStringArray	&saDataFiles		[O] t@C̃pX̔z
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMmeFile::GetDataFiles(CStringArray &saDataFiles)
{
	// .st@CpX擾
	CString sSearchPath;
	sSearchPath.Format("%s\\*.s", m_sDataFolder);

	// .st@C
	CFileFind oFileFind;
	if (oFileFind.FindFile(sSearchPath)) {
		BOOL bFndEnd = TRUE;
		while (bFndEnd) {
			bFndEnd = oFileFind.FindNextFile();

			if (!oFileFind.IsDirectory())
				saDataFiles.Add(oFileFind.GetFilePath());
		}
	}
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::GetTotalFileSize
//----------------------------------------------------------------------------------------------------
//  2. @\
//		f[^t@C̃TCY̍v擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CStringArray	&saDataFiles		[I] f[^t@C̃pX̔z
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		ULONGLONG		t@CTCY̍v
//*****************************************************************************************************
ULONGLONG CMmeFile::GetTotalFileSize(const CStringArray &saDataFiles)
{
	CFileStatus oStatus;
	ULONGLONG nTotalFileSize = 0;
	
	for (int i = 0; i < saDataFiles.GetCount(); i++) {
		CFile::GetStatus(saDataFiles[i], oStatus);
		nTotalFileSize += oStatus.m_size;
	}

	return nTotalFileSize;
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::CheckExistFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Hwlϊ̃t@Cɑ݂邩`FbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		DataBlock	&oDataBlock		[I] f[^ubN
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE:݂@FALSE:݂Ȃ
//*****************************************************************************************************
BOOL CMmeFile::CheckExistFile(const DataBlock &oDataBlock)
{
	CString sFolderPath;

	for (int nUnit = 0; nUnit < N_UNIT; nUnit++) {
		for (int nRange = 0; nRange < N_RANGE; nRange++) {
			for (int i = 0; i < oDataBlock[nUnit][nRange].GetCount(); i++) {
				const STimestampBlock &oTimestampBlock = oDataBlock[nUnit][nRange][i];
				GetOutputFolderName(nUnit, nRange, oTimestampBlock.nStartTimestamp, oTimestampBlock.nEndTimestamp, sFolderPath);
				if (::PathFileExists(sFolderPath))
					return TRUE;
			}
		}
	}

	return FALSE;
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::ConvDataFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		MMEf[^t@CHwlϊ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE:@FALSE:~܂̓G[
//*****************************************************************************************************
BOOL CMmeFile::ConvDataFile()
{
	CProgressBar cProgressBar;

	return cProgressBar.ExecProcess("Hwlϊ", 100, this, ConvDataThread);
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::ConvDataThread
//----------------------------------------------------------------------------------------------------
//  2. @\
//		HwlϊXbh̓
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPVOID			pParam			[I] CMmeFileNXւ̃|C^ithis|C^j
//		CProgressBar	*pProgressBar	[I] vOXo[
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE:@FALSE:~܂̓G[
//*****************************************************************************************************
BOOL CMmeFile::ConvDataThread(LPVOID pParam, CProgressBar *pProgressBar)
{
	return ((CMmeFile *)pParam)->ConvDataThread2(pProgressBar);
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::ConvDataThread2
//----------------------------------------------------------------------------------------------------
//  2. @\
//		HwlϊXbh̖{
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CProgressBar	*pProgressBar	[I] vOXo[
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE:@FALSE:~܂̓G[
//*****************************************************************************************************
BOOL CMmeFile::ConvDataThread2(CProgressBar *pProgressBar)
{
	// f[^t@CpX擾
	CStringArray saDataFiles;
	GetDataFiles(saDataFiles);	

	// ^CX^v擾
	TimestampArray oTimestampArray;
	if (GetTimestamp(saDataFiles, oTimestampArray, pProgressBar) == 0)
		return FALSE;

	// f[^ubN擾
	DataBlock oDataBlock;
	GetDataBlock(oTimestampArray, oDataBlock);

	// obt@m
	AllocateBuf(oDataBlock);

	// f[^ǂݍ
	if (!ReadData(oDataBlock, pProgressBar))
		return FALSE;

	// f[^x[X
	if (!WriteDatabase(oDataBlock, pProgressBar))
		return FALSE;

	m_bOverWrite = CheckExistFile(oDataBlock);

	pProgressBar->SetProgress(100);

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::ReadIniFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		mme.init@Cǂݍ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE:@FALSE:mme.init@C
//*****************************************************************************************************
BOOL CMmeFile::ReadIniFile()
{
	static const char *unit[N_UNIT] = {"ACC_SCALE_FACTOR_UNIT1", "ACC_SCALE_FACTOR_UNIT2", "ACC_SCALE_FACTOR_UNIT3"};
	static const char *axis[N_AXIS] = {"X", "Y", "Z"};
	static const char *range[N_RANGE] = {"Lo", "Hi", "Ex"};
	CString sKey;
	char buf[256];

	// init@CpX擾
	CString sIniFileName;
	sIniFileName.Format("%s\\%s", gExePath, MME_INI_FILE);

	// t@C݂Ȃ΃G[
	if (!::PathFileExists(sIniFileName)) {
		CGeneral::Alert("%s݂܂B", MME_INI_FILE);
		return FALSE;
	}

	// jbg̐[v
	for (int i = 0; i < N_UNIT; i++) {
		SAccFactor::SUnit *pUnit = &m_oAccFactor.unit[i];

		// W(XYZ)̐[v
		for (int j = 0; j < N_AXIS; j++) {
			SAccFactor::SUnit::SAxis *pAxis = &pUnit->axis[j];

			// vW̐[v
			for (int k = 0; k < N_RANGE; k++) {
				// init@C̃L[
				sKey.Format("%s-%s", axis[j], range[k]);

				// init@Cǂݍ
				GetPrivateProfileString(unit[i], sKey, "0", buf, sizeof(buf), sIniFileName);
				pAxis->range[k] = atof(buf);
			}
		}
	}

	// [b̎擾
	for (int i = 1; ; i++) {
		int nYear, nMonth, nDay;
		sKey.Format("DATE%d", i);
		GetPrivateProfileString("LEAP_SECOND", sKey, "", buf, sizeof(buf), sIniFileName);
		if (sscanf_s(buf, "%d/%d/%d", &nYear, &nMonth, &nDay) == 3)
			m_oLeapSecond.Add(CTime(nYear, nMonth, nDay, 8, 59, 59));
		else
			break;
	}

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::ReadSensorInfo
//----------------------------------------------------------------------------------------------------
//  2. @\
//		mme.init@CZT[ǂݍ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMmeFile::ReadSensorInfo()
{
	static const char *sensor[N_UNIT] = {"MME-S1", "MME-S2", "MME-S3"};
	char buf[256];

	// init@CpX擾
	CString sIniFileName;
	sIniFileName.Format("%s\\%s", gExePath, MME_INI_FILE);

	g_pSensorInfoMme = new SENSOR_INFO[N_UNIT];
	memset(g_pSensorInfoMme, 0, sizeof(SENSOR_INFO) * N_UNIT);

	// ZT[Wf[^̎擾
	for (int i = 0; i < N_UNIT; i++) {
		GetPrivateProfileString(sensor[i], "X", "0", buf, sizeof(buf), sIniFileName);
		g_pSensorInfoMme[i].x = atof(buf);

		GetPrivateProfileString(sensor[i], "Y", "0", buf, sizeof(buf), sIniFileName);
		g_pSensorInfoMme[i].y = atof(buf);

		GetPrivateProfileString(sensor[i], "Z", "0", buf, sizeof(buf), sIniFileName);
		g_pSensorInfoMme[i].z = atof(buf);

		GetPrivateProfileString(sensor[i], "Roll", "0", buf, sizeof(buf), sIniFileName);
		g_pSensorInfoMme[i].roll = atof(buf);

		GetPrivateProfileString(sensor[i], "Pitch", "0", buf, sizeof(buf), sIniFileName);
		g_pSensorInfoMme[i].pitch = atof(buf);

		GetPrivateProfileString(sensor[i], "Yaw", "0", buf, sizeof(buf), sIniFileName);
		g_pSensorInfoMme[i].yaw = atof(buf);
	}
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::ReadDataPacket
//----------------------------------------------------------------------------------------------------
//  2. @\
//		.st@CP̃f[^pPbgǂݍ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CFile		&oFile			[I] .st@C
//		SUserHeader	*pUserHeader	[O] [Uwb_obt@ւ̃|C^
//		void		*pDataBuf		[O] f[^obt@ւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE:@FALSE:t@C̏I[
//*****************************************************************************************************
BOOL CMmeFile::ReadDataPacket(CFile &oFile, SUserHeader *pUserHeader, void *pDataBuf)
{
	struct {
		char time[PACKET_TIME_SIZE];
		BYTE header[USER_HEADER_SIZE];
	} buf;
	UINT nDataNum;
	UINT nReadSize;
	int nHour, nMinute, nSecond;

	// .st@C̒XL
	BOOL bLoop = TRUE;
	while (bLoop) {
		// MƎMpPbg̃wb_ǂݍ
		if (oFile.Read(&buf, sizeof(buf)) != sizeof(buf))
			return FALSE;

		// f[^MtH[}bg`FbN
		if (sscanf_s(buf.time, "%2d:%2d:%2d", &nHour, &nMinute, &nSecond) != 3)
			return FALSE;

		// wb_̓eo
		pUserHeader->nPayloadId = buf.header[0];
		pUserHeader->nDataId = buf.header[1];
		pUserHeader->nFrameId = buf.header[2] >> 1;
		pUserHeader->nEndSegment = buf.header[2] & 0x01;
		pUserHeader->nSegmentCount = buf.header[3];
		pUserHeader->nTimestamp = GETDWORD(buf.header[4], buf.header[5], buf.header[6], buf.header[7]);

		// f[^ID
		if (pUserHeader->nDataId == 0x80) {
			// t[\ID
			switch (pUserHeader->nFrameId) {
			case 0x01:	// ʏV[PXLoWv[h
			case 0x02:	// ʏV[PXHiWv[h
			case 0x03:	// ʏV[PXgWv[h
			case 0x11:	// AV[PXLoWv[h
			case 0x12:	// AV[PXHiWv[h
			case 0x13:	// AV[PXgWv[h
				// egpPbg̓eo
				pUserHeader->TelemetryPacket.nMeasurementMode = (buf.header[10] >> 6) & 0x03;
				pUserHeader->TelemetryPacket.nMeasurementRange = (buf.header[10] >> 4) & 0x03;
				pUserHeader->TelemetryPacket.nSamplingRate = GETWORD(buf.header[10] & 0x0f, buf.header[11]);
				pUserHeader->TelemetryPacket.nDataNum = GETWORD(buf.header[12], buf.header[13]);
				pUserHeader->TelemetryPacket.nUnitRange[UNIT_1] = (buf.header[14] >> 3) & 0x03;
				pUserHeader->TelemetryPacket.nUnitRange[UNIT_2] = (buf.header[15] >> 6) & 0x03;
				pUserHeader->TelemetryPacket.nUnitRange[UNIT_3] = (buf.header[15] >> 1) & 0x03;

				// AiOj^XLbv
				if (pUserHeader->nSegmentCount == 0)
					oFile.Seek(48, CFile::current);

				// f[^obt@w肳Ă΂ɓǂݍށBw肳ĂȂΓǂݔ΂
				nReadSize = pUserHeader->TelemetryPacket.nDataNum * ACC_DATA_SIZE;
				if (pDataBuf != NULL)
					oFile.Read(pDataBuf, nReadSize);
				else
					oFile.Seek(nReadSize, CFile::current);

				bLoop = FALSE;
				break;
			case 0x04:	// MMEXe[^XpPbg
			case 0x05:	// G[Xe[^XpPbg
			case 0x06:	// bZ[WpPbg
				// f[^ǂݔ΂
				nDataNum = GETWORD(buf.header[12], buf.header[13]);
				oFile.Seek(nDataNum, CFile::current);
				break;
			}
		}
	}

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::GetTimestamp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		.st@C^CX^vǂݍ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CStringArray	&saDataFiles		[I] f[^t@C̃pX̔z
//		TimestampArray	&oTimestampArray	[O] ^CX^v
//		CProgressBar	*pProgressBar		[I] vOXo[
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE:@FALSE:~
//*****************************************************************************************************
BOOL CMmeFile::GetTimestamp(const CStringArray &saDataFiles, TimestampArray &oTimestampArray, CProgressBar *pProgressBar)
{
	CFile oFile;
	SUserHeader oUserHeader;
	TimestampMap oTimestampMap;
	UINT nTimestamp;
	UINT nPacketCount = 0;

	for (int i = 0; i < saDataFiles.GetCount(); i++) {
		if (oFile.Open(saDataFiles[i], CFile::modeRead | CFile::shareDenyWrite)) {
			while (true) {
				if (!ReadDataPacket(oFile, &oUserHeader, NULL))
					break;

				for (int nUnit = 0; nUnit < N_UNIT; nUnit++) {
					int nRange = -1;
					switch (oUserHeader.TelemetryPacket.nUnitRange[nUnit]) {
					case 0x01:	// LoWvf[^
						nRange = RANGE_LO;
						break;
					case 0x02:	// HiWvf[^
						nRange = RANGE_HI;
						break;
					case 0x03:	// gWvf[^
						nRange = RANGE_EX;
						break;
					}
					if (nRange != -1) {
						// Mapɒǉ
						if (!oTimestampMap[nUnit][nRange].Lookup(oUserHeader.nTimestamp, nTimestamp))
							oTimestampMap[nUnit][nRange].SetAt(oUserHeader.nTimestamp, oUserHeader.nTimestamp);

						// TvO[gۑ
						m_nSamplingRate[nRange] = oUserHeader.TelemetryPacket.nSamplingRate;
					}
				}

				// vOXo[\
				if (pProgressBar != NULL) {
					if (!pProgressBar->SetProgress((int)(10 * ++nPacketCount / m_nPacketCount)))
						return FALSE;
				} else
					m_nPacketCount++;
			}

			oFile.Close();
		}
	}

	for (int nUnit = 0; nUnit < N_UNIT; nUnit++) {
		for (int nRange = 0; nRange < N_RANGE; nRange++)
			GetTimestampArray(oTimestampMap[nUnit][nRange], oTimestampArray[nUnit][nRange]);
	}

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::GetTimestampArray
//----------------------------------------------------------------------------------------------------
//  2. @\
//		CMapTimestampCArrayTimestampɕϊă\[g
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CMapTimestamp	&oMapTimestamp		[I] vOXo[
//		TimestampArray	&oArrayTimestamp	[O] ^CX^vz
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMmeFile::GetTimestampArray(const CMapTimestamp &oMapTimestamp, CArrayTimestamp &oArrayTimestamp)
{
	UINT nKey;
	UINT nVal;

	// MapArrayփRs[
	POSITION pos = oMapTimestamp.GetStartPosition();
	while (pos != NULL) {
		oMapTimestamp.GetNextAssoc(pos, nKey, nVal);
		oArrayTimestamp.Add(nVal);
	}

	// ^CX^v\[g
	if (oArrayTimestamp.GetCount() != 0)
		qsort(oArrayTimestamp.GetData(), oArrayTimestamp.GetCount(), sizeof(UINT), CompareTimestamp);
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::CompareTimestamp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		^CX^v\[gp̔r֐
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		void	*p1			[I] ^CX^v1ւ̃|C^
//		void	*p2			[I] ^CX^v2ւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int		1:^CX^v1̕傫@-1:^CX^v2̕傫@0:
//*****************************************************************************************************
int CMmeFile::CompareTimestamp(const void *p1, const void *p2)
{
	if (*(UINT *)p1 > *(UINT *)p2)
		return 1;
	else if (*(UINT *)p1 < *(UINT *)p2)
		return -1;
	else
		return 0;
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::GetDataBlock
//----------------------------------------------------------------------------------------------------
//  2. @\
//		A^CX^vɃubN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		TimestampArray	&oTimestampArray	[I] ^CX^v̔z
//		DataBlock		&oDataBlock			[O] f[^ubN
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMmeFile::GetDataBlock(const TimestampArray &oTimestampArray, DataBlock &oDataBlock)
{
	// A^CX^ṽf[^܂Ƃ߂
	for (int nUnit = 0; nUnit < N_UNIT; nUnit++) {
		for (int nRange = 0; nRange < N_RANGE; nRange++) {
			UINT nCurrenttimestamp = 0;

			for (int i = 0; i < oTimestampArray[nUnit][nRange].GetCount(); i++) {
				UINT nTimestamp = oTimestampArray[nUnit][nRange][i];

				if (nTimestamp > nCurrenttimestamp + 1) {
					STimestampBlock oTimestampBlock;
					oTimestampBlock.nStartTimestamp = nTimestamp;
					oTimestampBlock.nEndTimestamp = nTimestamp;
					oTimestampBlock.nLastSeqCount = 0;
					oDataBlock[nUnit][nRange].Add(oTimestampBlock);
				}

				if (oDataBlock[nUnit][nRange].GetCount() != 0)
					oDataBlock[nUnit][nRange][oDataBlock[nUnit][nRange].GetCount() - 1].nEndTimestamp = nTimestamp;

				nCurrenttimestamp = nTimestamp;
			}
		}
	}
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::AllocateBuf
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ubÑf[^obt@mۂ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		DataBlock		&oDataBlock			[O] f[^ubN
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMmeFile::AllocateBuf(DataBlock &oDataBlock)
{
	// f[^obt@m
	for (int nUnit = 0; nUnit < N_UNIT; nUnit++) {
		for (int nRange = 0; nRange < N_RANGE; nRange++) {
			for (int i = 0; i < oDataBlock[nUnit][nRange].GetCount(); i++) {
				STimestampBlock &oTimestampBlock = oDataBlock[nUnit][nRange][i];
				UINT nBufSize = (oTimestampBlock.nEndTimestamp - oTimestampBlock.nStartTimestamp + 1) * m_nSamplingRate[nRange];
				oTimestampBlock.pAccData = new SAccData[nBufSize];
				memset(oTimestampBlock.pAccData, 0, nBufSize * sizeof(SAccData));
			}
		}
	}
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::ReadData
//----------------------------------------------------------------------------------------------------
//  2. @\
//		.st@CubNɃf[^ǂݍ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		DataBlock		&oDataBlock			[O] f[^ubN
//		CProgressBar	*pProgressBar		[I] vOXo[
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
BOOL CMmeFile::ReadData(DataBlock &oDataBlock, CProgressBar *pProgressBar)
{
	static const int nValidFlag[N_UNIT] = {0x10, 0x20, 0x40};

	CStringArray saDataFiles;
	GetDataFiles(saDataFiles);

	UINT nPacketCount = 0;
	CFile oFile;
	SUserHeader oUserHeader;
	BYTE *pBuf = new BYTE[65535 * ACC_DATA_SIZE];
	for (int i = 0; i < saDataFiles.GetCount(); i++) {
		if (oFile.Open(saDataFiles[i], CFile::modeRead | CFile::shareDenyWrite)) {
			while (true) {
				if (!ReadDataPacket(oFile, &oUserHeader, pBuf))
					break;

				for (int nUnit = 0; nUnit < N_UNIT; nUnit++) {
					int nRange = -1;
					switch (oUserHeader.TelemetryPacket.nUnitRange[nUnit]) {
					case 0x01:	// LoWvf[^
						nRange = RANGE_LO;
						break;
					case 0x02:	// HiWvf[^
						nRange = RANGE_HI;
						break;
					case 0x03:	// gWvf[^
						nRange = RANGE_EX;
						break;
					}

					if (nRange != -1) {
						for (int i = 0; i < oDataBlock[nUnit][nRange].GetCount(); i++) {
							STimestampBlock &oTimestampBlock = oDataBlock[nUnit][nRange][i];
							if (oUserHeader.nTimestamp >= oTimestampBlock.nStartTimestamp
									&& oUserHeader.nTimestamp <= oTimestampBlock.nEndTimestamp) {
								BYTE *pBuf2 = pBuf;
								for (UINT j = 0; j < oUserHeader.TelemetryPacket.nDataNum; j++) {
									UINT nSeqCount = GETWORD(pBuf2[0] & 0x0f, pBuf2[1]);
									if (nSeqCount > 0 && nSeqCount <= m_nSamplingRate[nRange]) {
										UINT nOffset = (oUserHeader.nTimestamp - oTimestampBlock.nStartTimestamp) * m_nSamplingRate[nRange] + (nSeqCount - 1);

										// stO擾
										oTimestampBlock.pAccData[nOffset].nValidFlag = pBuf2[0] & nValidFlag[nUnit];

										// xf[^擾
										for (int nAxis = 0; nAxis < N_AXIS; nAxis++) {
											UINT nIndex = 2 + nUnit * 6 + nAxis * 2;
											oTimestampBlock.pAccData[nOffset].nAccData[nAxis] = GETWORD(pBuf2[nIndex], pBuf2[nIndex + 1]);
										}

										pBuf2 += ACC_DATA_SIZE;

										if (oUserHeader.nTimestamp == oTimestampBlock.nEndTimestamp)
											oTimestampBlock.nLastSeqCount = max(oTimestampBlock.nLastSeqCount, nSeqCount);
									}
								}
								break;
							}
						}
					}
				}

				// vOXo[\
				if (pProgressBar != NULL && !pProgressBar->SetProgress(10 + (int)(20 * ++nPacketCount / m_nPacketCount))) {
					delete [] pBuf;
					return FALSE;
				}
			}

			oFile.Close();
		}
	}

	delete [] pBuf;

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::WriteDatabase
//----------------------------------------------------------------------------------------------------
//  2. @\
//		HwlϊsAf[^x[XtH_Ƀt@C
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		DataBlock		&oDataBlock			[O] f[^ubN
//		CProgressBar	*pProgressBar		[I] vOXo[
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE:@FALSE:~
//*****************************************************************************************************
BOOL CMmeFile::WriteDatabase(DataBlock &oDataBlock, CProgressBar *pProgressBar)
{
	CString sMeasTime;
	CString sFolderPath;
	CString sFilePath;
	CString sFileName;
	CStringArray saDataFilePath;
	INT64 nDataSize = 0;

	// vOXo[\pɑSf[^擾
	m_nTotalDataCount = 0;
	for (int nUnit = 0; nUnit < N_UNIT; nUnit++) {
		for (int nRange = 0; nRange < N_RANGE; nRange++) {
			for (int i = 0; i < oDataBlock[nUnit][nRange].GetCount(); i++) {
				STimestampBlock &oTimestampBlock = oDataBlock[nUnit][nRange][i];
				m_nTotalDataCount += (oTimestampBlock.nEndTimestamp - oTimestampBlock.nStartTimestamp) * m_nSamplingRate[nRange] + oTimestampBlock.nLastSeqCount;
			}
		}
	}

	for (int nUnit = 0; nUnit < N_UNIT; nUnit++) {
		for (int nRange = 0; nRange < N_RANGE; nRange++) {
			for (int i = 0; i < oDataBlock[nUnit][nRange].GetCount(); i++) {
				STimestampBlock &oTimestampBlock = oDataBlock[nUnit][nRange][i];

				// o̓tH_
				GetOutputFolderName(nUnit, nRange, oTimestampBlock.nStartTimestamp, oTimestampBlock.nEndTimestamp, sFolderPath);

				// fBNg쐬
				CGeneral::CreateDirectoryAll(sFolderPath);

				// Idbt@Cݒ
				SetIdbFile(sFolderPath, oTimestampBlock, nUnit, nRange);

				// sf[^u
				UINT nDataCount = (oTimestampBlock.nEndTimestamp - oTimestampBlock.nStartTimestamp) * m_nSamplingRate[nRange] + oTimestampBlock.nLastSeqCount;
				ReplaceInvalidData(oTimestampBlock, nDataCount);

				// PԖɍHwlϊt@C
				UINT n1HourDataSize = m_nSamplingRate[nRange] * 3600;
				UINT nDataTime = oTimestampBlock.nStartTimestamp;
				for (UINT nDataOffset = 0; nDataOffset < nDataCount; nDataOffset += n1HourDataSize) {
					UINT nWriteDataSize = min(n1HourDataSize, nDataCount - nDataOffset);

					// o̓t@C擾
					CTime oDataStartTime = GetTime(nDataTime);
					CTime oDataEndTime = GetTime(nDataTime + nWriteDataSize / m_nSamplingRate[nRange]);
					sFileName.Format("%s%c%s",
							oDataStartTime.FormatGmt("%Y_%m_%d_%H_%M_%S.000"),
							nDataOffset == 0 ? '-' : '+',
							oDataEndTime.FormatGmt("%Y_%m_%d_%H_%M_%S.000"));
					sFilePath.Format("%s\\%s", sFolderPath, sFileName);

					// f[^t@C
					if (!WriteDataFile(sFilePath, oTimestampBlock, nDataOffset, nWriteDataSize, nUnit, nRange, pProgressBar, nDataSize))
						return FALSE;

					// XMLt@C
					WriteXmlFile(sFileName, oDataStartTime);

					// f[^t@Cۑ
					m_oIdbFile.AddFile(sFileName);

					// Pԁi3600bjZ
					nDataTime += 3600;
				}

				// idbt@C
				WriteIdbFile(oTimestampBlock);
			}
		}
	}

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::GetOutputFolderName
//----------------------------------------------------------------------------------------------------
//  2. @\
//		o̓tH_pX擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int			nUnit				[I] jbgԍ
//		int			nRange				[I] Wԍ
//		UINT		nStartTimestamp		[I] Jn^CX^v
//		UINT		nEndTimestamp		[I] I^CX^v
//		CString		&sFolderPath		[O] o̓tH_pX
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	
//*****************************************************************************************************
void CMmeFile::GetOutputFolderName(int nUnit, int nRange, UINT nStartTimestamp, UINT nEndTimestamp, CString &sFolderPath)
{
	static const char *sUnit[N_UNIT] = {"Unit1", "Unit2", "Unit3"};
	static const char *sRange[N_RANGE] = {"Lo", "Hi", "Ex"};

	CTime oMeasStartTime = GetTime(nStartTimestamp);
	CTime oMeasEndTime = GetTime(nEndTimestamp);

	sFolderPath.Format("%s\\MME\\%s\\%s_%s_%s",
			gRootData,
			sUnit[nUnit],
			oMeasStartTime.FormatGmt("%Y_%m_%d_-%H_%M_%S_000"),
			oMeasEndTime.FormatGmt("%Y%m%d%H%M%S"),
			sRange[nRange]);
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::SetIdbFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		idbt@CɏZbg
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CString			&sFolderPath		[I] o̓tH_pX
//		STimestampBlock	&oTimestampBlock	[I] ^CX^vubN
//		int				nUnit				[I] jbgԍ
//		int				nRange				[I] Wԍ
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMmeFile::SetIdbFile(const CString &sFolderPath, const STimestampBlock &oTimestampBlock, int nUnit, int nRange)
{
	CString sBuf;

	CTime oStartTime = GetTime(oTimestampBlock.nStartTimestamp);
	CTime oEndTime = GetTime(oTimestampBlock.nEndTimestamp);

	struct tm tm;
	oStartTime.GetGmtTm(&tm);

	// f[^
	m_oIdbFile.DelAll();

	// ZT[IDX
	m_oIdbFile.SetSensorIdx(nUnit);

	// Rg
	m_oIdbFile.SetComment(m_sComment);

	// X^[g^CYYYYiNjMM()DD()SSSSSSSSi~bj
	m_oIdbFile.SetStartTime(1900 + tm.tm_year, 1 + tm.tm_mon, tm.tm_mday, (((tm.tm_hour * 60) + tm.tm_min) * 60 + tm.tm_sec) * 1000);

	// Tv[g
	m_oIdbFile.SetSampleRate((double)m_nSamplingRate[nRange]);

	// 
	sBuf.Format("%s-%s", oStartTime.FormatGmt("%Y%m%d%H%M%S"), oEndTime.FormatGmt("%Y%m%d%H%M%S"));
	m_oIdbFile.SetPeriod(sBuf);

	// _EN
	m_oIdbFile.SetDownlink(m_sDownlink);

	// ZT[ID
	m_oIdbFile.SetSensorId(nUnit + 1);

	// ^C[
	m_oIdbFile.SetTimeZero(oStartTime.FormatGmt("%Y%m%d%H%M%S"));

	// Sensor Co Sys
	sBuf.Format("MME-S%d", nUnit + 1);
	m_oIdbFile.SetSensorcosys(sBuf);

	// Data Co Sys
	sBuf.Format("MME-S%d", nUnit + 1);
	m_oIdbFile.SetDatacosys(sBuf);

	// ۑpX
	m_oIdbFile.SetPath(sFolderPath);
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::ReplaceInvalidData
//----------------------------------------------------------------------------------------------------
//  2. @\
//		sf[^u
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		STimestampBlock	&oTimestampBlock	[O] ^CX^vubN
//		UINT			nDataCount			[I] f[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMmeFile::ReplaceInvalidData(STimestampBlock &oTimestampBlock, UINT nDataCount)
{
	short nReplaceData[N_AXIS];
	UINT i, j;
	int nAxis;

	// uf[^
	for (nAxis = 0; nAxis < N_AXIS; nAxis++)
		nReplaceData[nAxis] = 0;

	// sf[^u
	for (i = 0; i < nDataCount; i++) {
		if (!oTimestampBlock.pAccData[i].nValidFlag) {
			// ̗Lf[^T
			if (i == 0 || oTimestampBlock.pAccData[i - 1].nValidFlag) {
				for (j = i; j < nDataCount; j++) {
					if (oTimestampBlock.pAccData[j].nValidFlag)
						break;
				}

				if (i == 0) {
					if (j < nDataCount) {
						// 擪ɕsf[^ꍇ͍ŏ̗Lf[^g
						for (nAxis = 0; nAxis < N_AXIS; nAxis++)
							nReplaceData[nAxis] = oTimestampBlock.pAccData[j].nAccData[nAxis];
					}
				} else {
					if (j < nDataCount) {
						// Ԃɕsf[^ꍇ͑O̗Lȃf[^̕ϒlg
						for (nAxis = 0; nAxis < N_AXIS; nAxis++)
							nReplaceData[nAxis] = (oTimestampBlock.pAccData[i - 1].nAccData[nAxis] + oTimestampBlock.pAccData[j].nAccData[nAxis]) / 2;
					} else {
						// ɕsf[^ꍇ͍Ō̗Lf[^g
						for (nAxis = 0; nAxis < N_AXIS; nAxis++)
							nReplaceData[nAxis] = oTimestampBlock.pAccData[i - 1].nAccData[nAxis];
					}
				}
			}

			// sf[^u
			for (nAxis = 0; nAxis < N_AXIS; nAxis++)
				oTimestampBlock.pAccData[i].nAccData[nAxis] = nReplaceData[nAxis];
		}
	}
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::WriteDataFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Hwlϊt@C
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CString			&sFilePath			[I] o̓t@CpX
//		STimestampBlock	&oTimestampBlock	[I] ^CX^vubN
//		UINT			nDataOffset			[I] f[^obt@ItZbg
//		UINT			nWriteDataSize		[I] ݃f[^
//		int				nUnit				[I] jbgԍ
//		int				nRange				[I] Wԍ
//		CProgressBar	*pProgressBar		[I] vOXo[
//		INT64			nDataSize			[I/O] ς݃f[^JEg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE:@FALSE:~
//*****************************************************************************************************
BOOL CMmeFile::WriteDataFile(const CString &sFilePath, const STimestampBlock &oTimestampBlock, UINT nDataOffset, UINT nWriteDataSize, int nUnit, int nRange, CProgressBar *pProgressBar, INT64 &nDataSize)
{
	// Hwlϊt@C̃wb_
	struct {
		INT32 nSeqNo;
		INT32 nDataSize;
		INT32 nDataSizeHour;
		char sFiller[4];
	} oHeader;

	CFile oFile;
	if (oFile.Open(sFilePath, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyWrite)) {
		// wb_
		memset(&oHeader, 0, sizeof(oHeader));
		oHeader.nSeqNo = nDataOffset / m_nSamplingRate[nRange] + 1;
		oHeader.nDataSize = nWriteDataSize;
		oHeader.nDataSizeHour = m_nSamplingRate[nRange] * 3600;
		oFile.Write(&oHeader, sizeof(oHeader));

		// f[^
		UINT nDataCount = 0;
		double aWriteBuf[100][7];
		memset(aWriteBuf, 0, sizeof(aWriteBuf));
		while (nDataCount < nWriteDataSize) {
			int nBufSize = min(100, nWriteDataSize - nDataCount);
			for (int i = 0; i < nBufSize; i++) {
				// Hwlϊ
				for (int nAxis = 0; nAxis < N_AXIS; nAxis++)
					aWriteBuf[i][4 + nAxis] = oTimestampBlock.pAccData[nDataOffset + nDataCount].nAccData[nAxis] * m_oAccFactor.unit[nUnit].axis[nAxis].range[nRange] * 1000000;

				nDataCount++;
			}

			// vOXo[\
			nDataSize += nBufSize;
			if (pProgressBar != NULL && !pProgressBar->SetProgress(30 + (int)((INT64)70 * nDataSize / m_nTotalDataCount)))
				return FALSE;

			// t@Cɏ
			oFile.Write(aWriteBuf, 7 * nBufSize * sizeof(double));
		}
	}

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::WriteXmlFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		XMLt@C
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CString		&sFileName				[I] o̓t@C
//		CTime		&oDataStartTime			[I] f[^̊Jn
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMmeFile::WriteXmlFile(const CString &sFileName, const CTime &oDataStartTime)
{
	// vJnҏW
	m_oIdbFile.SetTimeZeroXML(oDataStartTime.FormatGmt("%Y_%m_%d_%H_%M_%S.000"));

	// XMLt@C
	m_oIdbFile.WriteXml(sFileName, DATA_TYPE_MME);
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::WriteIdbFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		idbt@C
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CTime		&oTimestampBlock		[I] ^CX^vubN
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMmeFile::WriteIdbFile(const STimestampBlock &oTimestampBlock)
{
	CTime oStartTime = GetTime(oTimestampBlock.nStartTimestamp);

	struct tm tm;
	oStartTime.GetGmtTm(&tm);

	// t@CҏW
	CString sFileName;
	sFileName.Format("%04d%02d%02d%d", 1900 + tm.tm_year, 1 + tm.tm_mon, tm.tm_mday, (((tm.tm_hour * 60) + tm.tm_min) * 60 + tm.tm_sec) * 1000);

	// idbt@Cɏ
	m_oIdbFile.Write(sFileName);
}

//*****************************************************************************************************
//  1. ֐
//		CMmeFile::GetTime
//----------------------------------------------------------------------------------------------------
//  2. @\
//		^CX^vɕϊ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nTimestamp		[I] ^CX^v
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		CTime		
//*****************************************************************************************************
CTime CMmeFile::GetTime(UINT nTimestamp)
{
	// ɕϊ
	CTime oTime(nTimestamp + 315964800 - 16);

	// [b̕␳
	for (int i = 0; i < m_oLeapSecond.GetCount(); i++) {
		if (m_oLeapSecond[i] < oTime)
			oTime -= 1;
		else
			break;
	}

	return oTime;
}
